#include <avr/io.h>
#include <util/crc16.h>

#define ADC_RNG_CHANNEL 0

uint16_t seed;

uint8_t rnd_adc_read(void);

void rnd_init(void){
	seed = 0xFFFF;
	seed = _crc16_update(seed, rnd_adc_read());
	seed = _crc16_update(seed, rnd_adc_read());
}

uint8_t rnd_adc_read(void){
	uint8_t result = 0;
	
	ADMUX = ADC_RNG_CHANNEL | (1 << REFS0); // Select channel,  AVCC Reference voltage.
	
	ADCSR = (1<<ADEN) | (1 << ADPS1); // Enable ADC (Prescaler 4)
	
// 	for (uint8_t i = 0; i < 8; i++){
	ADCSR |= (1<<ADSC);
	while (ADCSR & (1<<ADSC)) {;}
// 		
// 		result = (ADCL & 1) << i;
// 		ADCH;         
// 	}
	result = ADCL;
	ADCH;
	
	return result;
}

uint8_t rnd_get_byte(void){
	seed = _crc16_update(seed, rnd_adc_read());
	return ((seed & 0xFF) ^ (seed >> 8));
}

void rnd_get_bytes(uint8_t* buffer, uint8_t length){
	for (uint8_t i = 0; i < length; i++){
		buffer[i] = rnd_get_byte();
	}
}