#ifndef _LCD_H

#include "common.h"

//#define LCD_8BIT_MODE
//#define LCD_CONTROL_PORT_NAME C
//#define LCD_DATA_PORT_NAME A
#define LCD_LINE_DATA_MODE (1 << 0)
#define LCD_LINE_READ      (1 << 2)
#define LCD_LINE_STROBE    (1 << 1)
#define LCD_BACKLIGHT      (1 << 3)
#define LCD_DATA_OFFSET 4
#define LCD_4BIT_MODE
#define LCD_PORT_NAME A

#include <stdlib.h>
#include <avr/io.h>
#include <util/delay_basic.h>
#include <util/delay.h>
#include <avr/pgmspace.h>

#define LCD_WIDTH 16
#define LCD_HEIGHT 2


void lcd_write(uint8_t control, uint8_t data);

void lcd_init(void);
void lcd_set_backlight(uint8_t on);

void lcd_home(void);
void lcd_clear(void);
void lcd_set_pos(uint8_t x, uint8_t y);

void lcd_define_char(uint8_t ichar, uint8_t linedata[8]);
void lcd_fill_char(char c, uint8_t count);

void lcd_write_char(char c);
void lcd_write_string(char s[], uint8_t length);
uint8_t lcd_write_string_sz(char* s);
uint8_t lcd_write_string_sz_P(char* s);
uint8_t lcd_write_string_sz_limit(char* s, uint8_t limit);
uint8_t lcd_write_byte(uint8_t b);
void lcd_write_byte_hex(uint8_t b);

#define _LCD_H
#endif
