#include "common.h"
#include "../common/cardreader_interface-common.h"
#include <stdio.h>
#include <avr/pgmspace.h>
#include "door.h"

#define CARDREADER_POWER_PORT PORTD
#define CARDREADER_POWER_DDR  DDRD
#define CARDREADER_POWER_PIN  4

#define CARDREADER_POWER_REQUEST_PIN   PINA
#define CARDREADER_POWER_REQUEST_DDR   DDRA
#define CARDREADER_POWER_REQUEST_LINE  6
#define CARDREADER_POWER_REQUEST_PCINT PCINT6

void cardreader_init(void);
void cardreader_powerup(void);
void cardreader_shutdown(void);
uint8_t cardreader_is_powered(void);
void card_power_request_pin_changed(uint8_t power_request);

void cardreader_process(void);
void cardreader_tick(void);

uint8_t cardreader_init_card_key(KEY key);
uint8_t cardreader_clear_card_key(void);

void cardreader_display_show_door_retry(void);
void cardreader_display_show_door_result(uint8_t success);