#include "../common/i2c_master.h"
#include "ds1307.h"
#include <stdio.h>
#include <avr/pgmspace.h>

extern void rtc_tick_handler(void);

void ds1307_init(void){
	i2c_master_init();
}

uint8_t ds1307_get_date(date_t* date){
	i2c_master_set_speed(I2C_BITRATE_REG_100K);
	return i2c_master_read(DS1307_I2C_ADDRESS, DS1307_REG_DATE, sizeof(uint8_t), (uint8_t*)date, sizeof(date_t)) == I2C_SUCCESS;
}

uint8_t ds1307_set_date(date_t* date){
	i2c_master_set_speed(I2C_BITRATE_REG_100K);
	return i2c_master_write(DS1307_I2C_ADDRESS, DS1307_REG_DATE, sizeof(uint8_t), (uint8_t*)date, sizeof(date_t)) == I2C_SUCCESS;
}
uint8_t ds1307_set_time(time_t* time){
	i2c_master_set_speed(I2C_BITRATE_REG_100K);
	return i2c_master_write(DS1307_I2C_ADDRESS, DS1307_REG_DATE, sizeof(uint8_t), (uint8_t*)time, sizeof(time_t)) == I2C_SUCCESS;	
}

void ds1307_write_date(date_t* date){
// 	char* wd[7] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
	printf_P(PSTR("%02x-%02x-20%02x %02x:%02x:%02x"), date->day, date->month, date->year, date->hour, date->minute, date->second);
}
void ds1307_write_current_date(void){
	date_t date;
	uint8_t ret = i2c_master_read(DS1307_I2C_ADDRESS, DS1307_REG_DATE, sizeof(uint8_t), (uint8_t*)&date, sizeof(date_t));
	if (ret == I2C_SUCCESS){
		ds1307_write_date(&date);
	} else {
		printf_P(PSTR("I2C Err %02x"), ret);
	}
}