#pragma once

#include <avr/io.h>
#include "../common/adc.h"
#include <stdio.h>
#include <avr/pgmspace.h>

#define POWER_PORT PORTA
#define POWER_PIN  PINA
#define POWER_DDR  DDRA

#define POWER_PIN_AC_ON                    0
#define POWER_PIN_MAIN_BATTERY_VOLTAGE     1
#define POWER_PIN_KEYMATIC_BATTERY_VOLTAGE 2
#define POWER_PIN_KEYMATIC_SUPPLY          7

#define POWER_STATUS_AC_ON             (1 << 0)
#define POWER_STATUS_MAIN_BATT_LOW     (1 << 1)
#define POWER_STATUS_KEYMATIC_BATT_LOW (1 << 2)

#define SET_BIT(x, b, v) {if (v) {x |= (b);} else {x &= ~(b);};}

#define POWER_MAIN_BATT_LOW_VOLTAGE     1100  //*10mv
#define POWER_KEYMATIC_BATT_LOW_VOLTAGE 300   //*10mv

void power_init(void);
void power_process(void);
void power_tick(void);

uint8_t power_get_status(void);
void power_update_batt_voltage(void);

void power_disable_battery_shutdown(void);
void power_enable_battery_shutdown(void);

void power_write_status(void);