#pragma once

#include "common.h"
#include <util/delay.h>
#include <avr/io.h>
#include <stdio.h>
#include <string.h>
#include <avr/pgmspace.h>

#define MAX_ARGS 3
#define MAX_CMD_LEN 32

typedef struct{
	char* cmd;
	uint8_t num_args;
	char* args[MAX_ARGS];
} readline_parsed_cmd_t;


typedef struct{
	char* cmd;
	uint8_t args_min;
	uint8_t args_max;
	void (*handler)(readline_parsed_cmd_t*);
} readline_supported_cmd_t;

extern readline_supported_cmd_t readline_commands[];

void readline_handle_buffer(char* input_buffer);

void readline_init(void);
void readline_show_welcome_prompt(void);
void readline_set_mode(char* prompt, uint8_t echo, uint8_t parse);
void readline_process(void);
void readline_write_prompt(void);