#include <avr/io.h>

#include "power_monitor.h"
#include "door.h"

#define LED_PORT PORTB
#define LED_DDR  DDRB
#define LED_POWER       (1 << 4)
#define LED_LOCKED      (1 << 3)
#define LED_OPEN        (1 << 2)
#define LED_UNLOCKED    (1 << 1)
#define LED_ALARM       (1 << 0)
#define LED_STATUS_MASK (LED_OPEN | LED_UNLOCKED | LED_ALARM | LED_LOCKED)
#define LED_MASK        (LED_STATUS_MASK | LED_POWER)
#define LED_FLAG_BLINK  0x80

void status_init(void);
void status_tick(void);

void status_update(uint8_t door_status_changed, uint8_t power_status_changed);

void status_process(void);