// #ifndef _I2C_COMMON_H
// #define _I2C_COMMON_H

#include <util/twi.h>
#include <avr/io.h> 
#include "common.h"

#define I2C_MODE_READ 1
#define I2C_MODE_WRITE 0

//SCL_Freq = F_CPU/(16+2(TWBR)*4**TWPS)
#define I2C_BITRATE_REG_100K 92 //20Mhz -> 100kHz I²C
#define I2C_BITRATE_REG_400K 17 //20Mhz -> 400kHz I²C
#define I2C_BITRATE_REG_1M   2  //20Mhz -> 1MHz I²C
#define I2C_PRESCALER 0

#define I2C_STATUS_MASK ((unsigned char)~I2C_PRESCALER) //only need to mask prescaler bits if they are actually present, instead of always masking 0xF8.

#define I2C_ADDRESS_BROADCAST 0

// #endif