#include "common.h"
#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <util/crc16.h>
#include <stdio.h>
 

#define TRANSPORT_ERR_TIMEOUT 0xFFFF
#define TRANSPORT_ERR_CHECKSUM_FAIL 0xFFEE
#define TRANSPORT_ERR_MESSAGE_TOO_LONG 0xFFCC
#define TRANSPORT_IS_ERROR(ret) (((ret) & 0xFF00) != 0)

typedef void (*interrupt_msg_handler_t)(void);


void transport_init(void);
void transport_set_interrupt_handler(uint8_t interrupt, interrupt_msg_handler_t handler);
uint8_t transport_data_available(void);
uint16_t transport_receive_message(uint8_t* buffer, uint8_t length, uint16_t timeout);
void transport_send_message(uint8_t* body, uint8_t length);
void transport_send_interrupt_message(uint8_t interrupt);
void transport_flush(void);